## freecad 0.20.1+dfsg1

=== CMakeLists.txt ===
# March 2021, the oldest we have to support : Ununtu 18.04 LTS
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

# policy CMP0072 was introduced with CMake 3.11
# relates to FindOpenGL module
# and cache variables OPENGL_gl_LIBRARY, OPENGL_glu_LIBRARY
if (POLICY CMP0072)
    cmake_policy(SET CMP0072 OLD)
endif(POLICY CMP0072)

find_program(CCACHE_PROGRAM ccache)  #This check should occur before project()
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

project(FreeCAD)

set(PACKAGE_VERSION_NAME "Vulcan")
set(PACKAGE_VERSION_MAJOR "0")
set(PACKAGE_VERSION_MINOR "20")
set(PACKAGE_VERSION_PATCH "1")
set(PACKAGE_VERSION_SUFFIX "") # either "dev" for development snapshot or "" (empty string)
set(FREECAD_VERSION_PATCH "1") # number of patch release (e.g. "4" for the 0.18.4 release)

set(FREECAD_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}")
set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
set(PACKAGE_STRING "${PROJECT_NAME} ${PACKAGE_VERSION}")

# include local modules
include(CheckCXXCompilerFlag)
include(AddFileDependencies)
include(cMake/FreeCadMacros.cmake)
# include helper functions/macros
add_subdirectory(cMake/FreeCAD_Helpers)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

CompilerChecksAndSetups()
ConfigureCMakeVariables()
InitializeFreeCADBuildOptions()
CheckInterModuleDependencies()
FreeCADLibpackChecks()
SetupDoxygen()
if(NOT FREECAD_LIBPACK_USE OR FREECAD_LIBPACK_CHECKFILE_CLBUNDLER)
    SetupPython()
    SetupPCL()
    SetupPybind11()
    SetupXercesC()
    find_package(ZLIB REQUIRED)
    find_package(PyCXX REQUIRED)
    SetupOpenCasCade()
    if(BUILD_GUI)
        # Do this before the check for SMESH because it depends on vtk
        # that may have its own OpenGL check but possibly fails and leaves
        # OPENGL_gl_LIBRARY empty that results into linker errors
        SetupOpenGL()
    endif(BUILD_GUI)
    SetupSalomeSMESH()
    SetupBoost()
    if (BUILD_FEM_NETGEN)
        find_package(NETGEN)
    endif(BUILD_FEM_NETGEN)
    # not needed at the moment
    #find_package(OpenCV REQUIRED)
    SetupSwig()
    SetupEigen()
    # This file is included directly due to some cMake macros that are defined within.
    # If these macro definitions are embedded within another macro, it causes problems.
    include(cMake/FreeCAD_Helpers/SetupQt.cmake)
    SetupFreetype()

    if(BUILD_GUI)
        SetupCoin3D()
        SetupSpaceball()
        SetupShibokenAndPyside()
        SetupMatplotlib()
    endif(BUILD_GUI)
endif(NOT FREECAD_LIBPACK_USE OR FREECAD_LIBPACK_CHECKFILE_CLBUNDLER)

if(BUILD_VR)
    find_package(Rift)
endif(BUILD_VR)

SetLibraryVersions()
SetGlobalCompilerAndLinkerSettings()

add_subdirectory(src)
add_subdirectory(data)

BuildAndInstallDesignerPlugin()

CreatePackagingTargets()

PrintFinalReport()

=== src/Mod/Drawing/App/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DFCAppDrawing -DHAVE_ACOSH -DHAVE_ASINH -DHAVE_ATANH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H -DHAVE_ACOSH -DHAVE_ATANH -DHAVE_ASINH)
endif(MSVC)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
)
link_directories(${OCC_LIBRARY_DIR})

set(Drawing_LIBS
    Part
    Spreadsheet
    FreeCADApp
)

SET(Features_SRCS
    FeaturePage.cpp
    FeaturePage.h
    FeatureProjection.cpp
    FeatureProjection.h
    FeatureView.cpp
    FeatureView.h
    FeatureViewPart.cpp
    FeatureViewPart.h
    FeatureViewAnnotation.cpp
    FeatureViewAnnotation.h
    FeatureViewSymbol.cpp
    FeatureViewSymbol.h
    FeatureClip.cpp
    FeatureClip.h
    PageGroup.cpp
    PageGroup.h
    FeatureViewSpreadsheet.cpp
    FeatureViewSpreadsheet.h
)

SET(Drawing_SRCS
    AppDrawing.cpp
    AppDrawingPy.cpp
    PreCompiled.cpp
    PreCompiled.h
)

SET(DrawingAlgos_SRCS
    DrawingExport.cpp
    DrawingExport.h
    ProjectionAlgos.cpp
    ProjectionAlgos.h
)

SOURCE_GROUP("Mod" FILES ${Drawing_SRCS})
SOURCE_GROUP("Features" FILES ${Features_SRCS})
SOURCE_GROUP("Algorithms" FILES ${DrawingAlgos_SRCS})

add_library(Drawing SHARED ${Drawing_SRCS} ${Features_SRCS} ${DrawingAlgos_SRCS})
target_link_libraries(Drawing ${Drawing_LIBS})

SET_BIN_DIR(Drawing Drawing /Mod/Drawing)
SET_PYTHON_PREFIX_SUFFIX(Drawing)

INSTALL(TARGETS Drawing DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Drawing/Gui/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DHAVE_ATANH -DHAVE_ASINH -DHAVE_ACOSH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
)
link_directories(${OCC_LIBRARY_DIR})

set(DrawingGui_LIBS
    Drawing
    FreeCADGui
)

set(DrawingGui_UIC_SRCS
    TaskOrthoViews.ui
)

if(BUILD_QT5)
    qt5_add_resources(DrawingGui_SRCS Resources/Drawing.qrc)
    qt5_wrap_ui(DrawingGui_UIC_HDRS ${DrawingGui_UIC_SRCS})
else()
    qt4_add_resources(DrawingGui_SRCS Resources/Drawing.qrc)
    qt4_wrap_ui(DrawingGui_UIC_HDRS ${DrawingGui_UIC_SRCS})
endif()

SET(DrawingGui_SRCS
    ${DrawingGui_SRCS}
    AppDrawingGui.cpp
    AppDrawingGuiPy.cpp
    Command.cpp
    Resources/Drawing.qrc
    PreCompiled.cpp
    PreCompiled.h
    TaskDialog.cpp
    TaskDialog.h
    TaskOrthoViews.ui
    TaskOrthoViews.cpp
    TaskOrthoViews.h
    Workbench.cpp
    Workbench.h
)
SET(DrawingGuiView_SRCS
    DrawingView.cpp
    DrawingView.h
)
SET(DrawingGuiViewProvider_SRCS
    ViewProviderPage.cpp
    ViewProviderPage.h
    ViewProviderView.cpp
    ViewProviderView.h
)

SOURCE_GROUP("Mod" FILES ${DrawingGui_SRCS})
SOURCE_GROUP("SVG-View" FILES ${DrawingGuiView_SRCS})
SOURCE_GROUP("ViewProvider" FILES ${DrawingGuiViewProvider_SRCS})

SET(DrawingGuiTaskDlgs_SRCS
    TaskOrthoViews.ui
)
SOURCE_GROUP("TaskDialogs" FILES ${DrawingGuiTaskDlgs_SRCS})

SET(DrawingGuiIcon_SVG
    Resources/icons/DrawingWorkbench.svg
)

add_library(DrawingGui SHARED ${DrawingGui_SRCS} ${DrawingGuiView_SRCS}
                              ${DrawingGuiViewProvider_SRCS} ${DrawingGuiIcon_SVG})
target_link_libraries(DrawingGui ${DrawingGui_LIBS})


SET_BIN_DIR(DrawingGui DrawingGui /Mod/Drawing)
SET_PYTHON_PREFIX_SUFFIX(DrawingGui)

fc_copy_sources(DrawingGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Drawing" ${DrawingGuiIcon_SVG})

INSTALL(TARGETS DrawingGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${DrawingGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Drawing/Resources/icons")

=== src/Mod/Image/Gui/CMakeLists.txt ===

if(OPENCV2_FOUND)
    add_definitions(-DHAVE_OPENCV2)
endif(OPENCV2_FOUND)


include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}
    ${OPENCV2_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
)

if(MSVC)
    include_directories(
        ${CMAKE_SOURCE_DIR}/src/3rdParty/OpenGL/api
    )
endif(MSVC)

set(ImageGui_LIBS
    Image
    FreeCADGui
    ${OpenCV2_LIBRARIES}
    ${OPENGL_glu_LIBRARY}
)

SET(ImageGui_RES_SRCS
    Resources/Image.qrc
)

set(ImageGui_UIC_SRCS
    ImageOrientationDialog.ui
)

if(BUILD_QT5)
    qt5_add_resources(ImageGui_QRC_SRCS ${ImageGui_RES_SRCS})
    qt5_wrap_ui(ImageGui_UIC_HDRS ${ImageGui_UIC_SRCS})
else()
    qt4_add_resources(ImageGui_QRC_SRCS ${ImageGui_RES_SRCS})
    qt4_wrap_ui(ImageGui_UIC_HDRS ${ImageGui_UIC_SRCS})
endif()

SET(ImageGui_SRCS
    ${ImageGui_QRC_SRCS}
    ${ImageGui_UIC_HDRS}
    AppImageGui.cpp
    AppImageGuiPy.cpp
    Command.cpp
    ImageOrientationDialog.cpp
    ImageOrientationDialog.h
    OpenGLImageBox.cpp
    OpenGLImageBox.h
    ViewProviderImagePlane.cpp
    ViewProviderImagePlane.h
    Resources/Image.qrc
    ImageView.cpp
    ImageView.h
    PreCompiled.cpp
    PreCompiled.h
    Workbench.cpp
    Workbench.h
    XpmImages.h
)

SET(ImageGuiIcon_SVG
    Resources/icons/ImageWorkbench.svg
)

add_library(ImageGui SHARED ${ImageGui_SRCS} ${ImageGuiIcon_SVG})
target_link_libraries(ImageGui ${ImageGui_LIBS})


SET_BIN_DIR(ImageGui ImageGui /Mod/Image)
SET_PYTHON_PREFIX_SUFFIX(ImageGui)

fc_copy_sources(ImageGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Image" ${ImageGuiIcon_SVG})

INSTALL(TARGETS ImageGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${ImageGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Image/Resources/icons")

=== src/Mod/Import/App/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DFCAppImport -DHAVE_ACOSH -DHAVE_ASINH -DHAVE_ATANH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)


include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
)

link_directories(${OCC_LIBRARY_DIR})

set(Import_LIBS
    Part
    ${OCC_OCAF_LIBRARIES}
    ${OCC_OCAF_DEBUG_LIBRARIES}
)

SET(Import_SRCS
    AppImport.cpp
    AppImportPy.cpp
    ExportOCAF.cpp
    ExportOCAF.h
    ImportOCAF.cpp
    ImportOCAF.h
    ImportOCAF2.cpp
    ImportOCAF2.h
    #ImportOCAFAssembly.cpp
    #ImportOCAFAssembly.h
    StepShapePy.xml
    StepShape.h
    StepShape.cpp
    StepShapePyImp.cpp
    PreCompiled.cpp
    PreCompiled.h
    ImpExpDxf.cpp
    ImpExpDxf.h
    dxf.cpp
    dxf.h
)

SET(SCL_Resources
    SCL/__init__.py
    SCL/AggregationDataTypes.py
    SCL/BaseType.py
    SCL/Builtin.py
    SCL/ConstructedDataTypes.py
    SCL/essa_par.py
    SCL/Model.py
    SCL/Part21.py
    SCL/Rules.py
    SCL/SCLBase.py
    SCL/SimpleDataTypes.py
    SCL/TypeChecker.py
    SCL/Utils.py
    SCL/SimpleReader.py
    SCL/Aufspannung.stp
    SCL/gasket1.p21
    SCL/Product1.stp
    automotive_design.py     # AP214e3
    ifc2x3.py                # IFC
    ifc4.py                  # IFC 4
    PlmXmlParser.py
)
SOURCE_GROUP("SCL" FILES ${SCL_Resources})

generate_from_xml(StepShapePy)

add_library(Import SHARED ${Import_SRCS})
target_link_libraries(Import ${Import_LIBS})

ADD_CUSTOM_TARGET(ImportPy ALL
    SOURCES ${SCL_Resources}
)

fc_target_copy_resource(ImportPy 
    ${CMAKE_SOURCE_DIR}/src/Mod/Import/App
    ${CMAKE_BINARY_DIR}/Mod/Import
    ${SCL_Resources})

SET_BIN_DIR(Import Import /Mod/Import)
SET_PYTHON_PREFIX_SUFFIX(Import)

INSTALL(TARGETS Import DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Import/Gui/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DFCAppPart -DHAVE_ACOSH -DHAVE_ASINH -DHAVE_ATANH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)


include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${COIN3D_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
)

link_directories(${OCC_LIBRARY_DIR})

set(ImportGui_LIBS
    FreeCADGui
    PartGui
    Import
    ${OCC_OCAF_LIBRARIES}
    ${OCC_OCAF_DEBUG_LIBRARIES}
)

SET(ImportGui_SRCS
    AppImportGui.cpp
    AppImportGuiPy.cpp
    Command.cpp
    PreCompiled.cpp
    PreCompiled.h
    Workbench.cpp
    Workbench.h
)

add_library(ImportGui SHARED ${ImportGui_SRCS})
target_link_libraries(ImportGui ${ImportGui_LIBS})


SET_BIN_DIR(ImportGui ImportGui /Mod/Import)
SET_PYTHON_PREFIX_SUFFIX(ImportGui)

INSTALL(TARGETS ImportGui DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Inspection/App/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DHAVE_ACOSH -DHAVE_ASINH -DHAVE_ATANH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

link_directories(${OCC_LIBRARY_DIR})

set(Inspection_LIBS
    FreeCADApp
    Mesh
    Points
    Part
)

SET(Inspection_SRCS
    AppInspection.cpp
    InspectionFeature.cpp
    InspectionFeature.h
    PreCompiled.cpp
    PreCompiled.h
)

set(Inspection_Scripts
    ../Init.py
)

add_library(Inspection SHARED ${Inspection_SRCS} ${Inspection_Scripts})
target_link_libraries(Inspection ${Inspection_LIBS})


fc_target_copy_resource_flat(Inspection
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/Mod/Inspection
    ${Inspection_Scripts}
)

SET_BIN_DIR(Inspection Inspection /Mod/Inspection)
SET_PYTHON_PREFIX_SUFFIX(Inspection)

INSTALL(TARGETS Inspection DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Inspection/Gui/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

link_directories(${OCC_LIBRARY_DIR})

set(InspectionGui_LIBS
    Inspection
    FreeCADGui
)

set(Dialogs_UIC_SRCS
    VisualInspection.ui
)

if(BUILD_QT5)
    qt5_add_resources(Inspection_QRC_SRCS Resources/Inspection.qrc)
    qt5_wrap_ui(Dialogs_UIC_HDRS ${Dialogs_UIC_SRCS})
else()
    qt4_add_resources(Inspection_QRC_SRCS Resources/Inspection.qrc)
    qt4_wrap_ui(Dialogs_UIC_HDRS ${Dialogs_UIC_SRCS})
endif()

SET(Dialogs_SRCS
    ${Dialogs_UIC_HDRS}
    VisualInspection.cpp
    VisualInspection.h
)
SOURCE_GROUP("Dialogs" FILES ${Dialogs_SRCS})

SET(InspectionGui_SRCS
    ${Inspection_QRC_SRCS}
    ${Dialogs_SRCS}
    AppInspectionGui.cpp
    Command.cpp
    PreCompiled.cpp
    PreCompiled.h
    ViewProviderInspection.cpp
    ViewProviderInspection.h
    Workbench.cpp
    Workbench.h
)

set(InspectionGui_Scripts
    ../InitGui.py
)

SET(InspectionGuiIcon_SVG
    Resources/icons/InspectionWorkbench.svg
)

add_library(InspectionGui SHARED ${InspectionGui_SRCS} ${InspectionGui_Scripts} ${InspectionGuiIcon_SVG})
target_link_libraries(InspectionGui ${InspectionGui_LIBS})


fc_target_copy_resource_flat(InspectionGui
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/Mod/Inspection
    ${InspectionGui_Scripts}
)

SET_BIN_DIR(InspectionGui InspectionGui /Mod/Inspection)
SET_PYTHON_PREFIX_SUFFIX(InspectionGui)

fc_copy_sources(InspectionGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Inspection" ${InspectionGuiIcon_SVG})

INSTALL(TARGETS InspectionGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${InspectionGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Inspection/Resources/icons")

=== src/Mod/Mesh/App/CMakeLists.txt ===
if(WIN32)
    add_definitions(-DFCAppMesh -DWM4_FOUNDATION_DLL_EXPORT)
endif(WIN32)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/3rdParty/libkdtree
    ${Boost_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${EIGEN3_INCLUDE_DIR}
)

set(Mesh_LIBS
    ${Boost_LIBRARIES}
    FreeCADBase
    FreeCADApp
)

if (BUILD_QT5)
    include_directories(
        ${Qt5Concurrent_INCLUDE_DIRS}
    )
    list(APPEND Mesh_LIBS
        ${Qt5Concurrent_LIBRARIES}
    )
endif()

generate_from_xml(EdgePy)
generate_from_xml(FacetPy)
generate_from_xml(MeshFeaturePy)
generate_from_xml(MeshPointPy)
generate_from_xml(MeshPy)

SET(Mesh_XML_SRCS
    EdgePy.xml
    FacetPy.xml
    MeshFeaturePy.xml
    MeshPointPy.xml
    MeshPy.xml
)
SOURCE_GROUP("XML" FILES ${Mesh_XML_SRCS})

SET(Core_SRCS
    Core/Algorithm.cpp
    Core/Algorithm.h
    Core/Approximation.cpp
    Core/Approximation.h
    Core/Builder.cpp
    Core/Builder.h
    Core/Curvature.cpp
    Core/Curvature.h
    Core/Decimation.cpp
    Core/Decimation.h
    Core/Definitions.cpp
    Core/Definitions.h
    Core/Degeneration.cpp
    Core/Degeneration.h
    Core/Elements.cpp
    Core/Elements.h
    Core/Evaluation.cpp
    Core/Evaluation.h
    Core/Grid.cpp
    Core/Grid.h
    Core/Helpers.h
    Core/Info.cpp
    Core/Info.h
    Core/Iterator.h
    Core/KDTree.cpp
    Core/KDTree.h
    Core/MeshIO.cpp
    Core/MeshIO.h
    Core/MeshKernel.cpp
    Core/MeshKernel.h
    Core/Projection.cpp
    Core/Projection.h
    Core/Segmentation.cpp
    Core/Segmentation.h
    Core/SetOperations.cpp
    Core/SetOperations.h
    Core/Smoothing.cpp
    Core/Smoothing.h
    Core/Tools.cpp
    Core/Tools.h
    Core/TopoAlgorithm.cpp
    Core/TopoAlgorithm.h
    Core/Triangulation.cpp
    Core/Triangulation.h
    Core/Trim.cpp
    Core/Trim.h
    Core/TrimByPlane.cpp
    Core/TrimByPlane.h
    Core/tritritest.h
    Core/Utilities.h
    Core/Visitor.cpp
    Core/Visitor.h
    Core/CylinderFit.cpp
    Core/CylinderFit.h
    Core/SphereFit.cpp
    Core/SphereFit.h
)
SOURCE_GROUP("Core" FILES ${Core_SRCS})

SET(WildMagic4_SRCS
    WildMagic4/Wm4ApprCylinderFit3.cpp
    WildMagic4/Wm4ApprCylinderFit3.h
    WildMagic4/Wm4ApprGaussPointsFit2.cpp
    WildMagic4/Wm4ApprGaussPointsFit2.h
    WildMagic4/Wm4ApprGaussPointsFit3.cpp
    WildMagic4/Wm4ApprGaussPointsFit3.h
    WildMagic4/Wm4ApprLineFit3.cpp
    WildMagic4/Wm4ApprLineFit3.h
    WildMagic4/Wm4ApprPlaneFit3.cpp
    WildMagic4/Wm4ApprPlaneFit3.h
    WildMagic4/Wm4ApprPolyFit3.cpp
    WildMagic4/Wm4ApprPolyFit3.h
    WildMagic4/Wm4ApprQuadraticFit3.cpp
    WildMagic4/Wm4ApprQuadraticFit3.h
    WildMagic4/Wm4ApprSphereFit3.cpp
    WildMagic4/Wm4ApprSphereFit3.h
    WildMagic4/Wm4BandedMatrix.h
    WildMagic4/Wm4BandedMatrix.inl
    WildMagic4/Wm4Box2.h
    WildMagic4/Wm4Box2.inl
    WildMagic4/Wm4Box3.h
    WildMagic4/Wm4Box3.inl
    WildMagic4/Wm4ContBox2.cpp
    WildMagic4/Wm4ContBox2.h
    WildMagic4/Wm4ContBox3.cpp
    WildMagic4/Wm4ContBox3.h
    WildMagic4/Wm4ConvexHull.cpp
    WildMagic4/Wm4ConvexHull.h
    WildMagic4/Wm4ConvexHull1.cpp
    WildMagic4/Wm4ConvexHull1.h
    WildMagic4/Wm4ConvexHull2.cpp
    WildMagic4/Wm4ConvexHull2.h
    WildMagic4/Wm4ConvexHull3.cpp
    WildMagic4/Wm4ConvexHull3.h
    WildMagic4/Wm4DelPolygonEdge.cpp
    WildMagic4/Wm4DelPolygonEdge.h
    WildMagic4/Wm4DelPolyhedronFace.cpp
    WildMagic4/Wm4DelPolyhedronFace.h
    WildMagic4/Wm4DelTetrahedron.cpp
    WildMagic4/Wm4DelTetrahedron.h
    WildMagic4/Wm4DelTriangle.cpp
    WildMagic4/Wm4DelTriangle.h
    WildMagic4/Wm4Delaunay.cpp
    WildMagic4/Wm4Delaunay.h
    WildMagic4/Wm4Delaunay1.cpp
    WildMagic4/Wm4Delaunay1.h
    WildMagic4/Wm4Delaunay2.cpp
    WildMagic4/Wm4Delaunay2.h
    WildMagic4/Wm4Delaunay3.cpp
    WildMagic4/Wm4Delaunay3.h
    WildMagic4/Wm4DistLine3Segment3.cpp
    WildMagic4/Wm4DistLine3Segment3.h
    WildMagic4/Wm4DistLine3Triangle3.cpp
    WildMagic4/Wm4DistLine3Triangle3.h
    WildMagic4/Wm4DistSegment3Segment3.cpp
    WildMagic4/Wm4DistSegment3Segment3.h
    WildMagic4/Wm4DistSegment3Triangle3.cpp
    WildMagic4/Wm4DistSegment3Triangle3.h
    WildMagic4/Wm4DistVector3Plane3.cpp
    WildMagic4/Wm4DistVector3Plane3.h
    WildMagic4/Wm4DistVector3Segment3.cpp
    WildMagic4/Wm4DistVector3Segment3.h
    WildMagic4/Wm4DistVector3Triangle3.cpp
    WildMagic4/Wm4DistVector3Triangle3.h
    WildMagic4/Wm4Distance.cpp
    WildMagic4/Wm4Distance.h
    WildMagic4/Wm4ETManifoldMesh.cpp
    WildMagic4/Wm4ETManifoldMesh.h
    WildMagic4/Wm4ETManifoldMesh.inl
    WildMagic4/Wm4EdgeKey.h
    WildMagic4/Wm4EdgeKey.inl
    WildMagic4/Wm4Eigen.cpp
    WildMagic4/Wm4Eigen.h
    WildMagic4/Wm4Foundation.h
    WildMagic4/Wm4FoundationLIB.h
    WildMagic4/Wm4FoundationPCH.cpp
    WildMagic4/Wm4FoundationPCH.h
    WildMagic4/Wm4GMatrix.h
    WildMagic4/Wm4GMatrix.inl
    WildMagic4/Wm4GVector.h
    WildMagic4/Wm4GVector.inl
    WildMagic4/Wm4ImplicitSurface.cpp
    WildMagic4/Wm4ImplicitSurface.h
    WildMagic4/Wm4Intersector.cpp
    WildMagic4/Wm4Intersector.h
    WildMagic4/Wm4Intersector1.cpp
    WildMagic4/Wm4Intersector1.h
    WildMagic4/Wm4IntrLine3Box3.cpp
    WildMagic4/Wm4IntrLine3Box3.h
    WildMagic4/Wm4IntrLine3Plane3.cpp
    WildMagic4/Wm4IntrLine3Plane3.h
    WildMagic4/Wm4IntrSegment3Box3.cpp
    WildMagic4/Wm4IntrSegment3Box3.h
    WildMagic4/Wm4IntrSegment3Plane3.cpp
    WildMagic4/Wm4IntrSegment3Plane3.h
    WildMagic4/Wm4IntrTriangle2Triangle2.cpp
    WildMagic4/Wm4IntrTriangle2Triangle2.h
    WildMagic4/Wm4IntrTriangle3Triangle3.cpp
    WildMagic4/Wm4IntrTriangle3Triangle3.h
    WildMagic4/Wm4LinComp.h
    WildMagic4/Wm4LinComp.inl
    WildMagic4/Wm4Line3.h
    WildMagic4/Wm4Line3.inl
    WildMagic4/Wm4LinearSystem.cpp
    WildMagic4/Wm4LinearSystem.h
    WildMagic4/Wm4Mapper2.h
    WildMagic4/Wm4Mapper2.inl
    WildMagic4/Wm4Mapper3.h
    WildMagic4/Wm4Mapper3.inl
    WildMagic4/Wm4Math.cpp
    WildMagic4/Wm4Math.h
    WildMagic4/Wm4Math.inl
    WildMagic4/Wm4MathMCR.h
    WildMagic4/Wm4Matrix2.cpp
    WildMagic4/Wm4Matrix2.h
    WildMagic4/Wm4Matrix2.inl
    WildMagic4/Wm4Matrix3.cpp
    WildMagic4/Wm4Matrix3.h
    WildMagic4/Wm4Matrix3.inl
    WildMagic4/Wm4Matrix4.cpp
    WildMagic4/Wm4Matrix4.h
    WildMagic4/Wm4Matrix4.inl
    WildMagic4/Wm4Memory.cpp
    WildMagic4/Wm4Memory.h
    WildMagic4/Wm4Memory.inl
    WildMagic4/Wm4MeshCurvature.cpp
    WildMagic4/Wm4MeshCurvature.h
    WildMagic4/Wm4MeshSmoother.cpp
    WildMagic4/Wm4MeshSmoother.h
    WildMagic4/Wm4ParametricSurface.cpp
    WildMagic4/Wm4ParametricSurface.h
    WildMagic4/Wm4Plane3.h
    WildMagic4/Wm4Plane3.inl
    WildMagic4/Wm4Platforms.h
    WildMagic4/Wm4PolynomialRoots.cpp
    WildMagic4/Wm4PolynomialRoots.h
    WildMagic4/Wm4Polynomial1.h
    WildMagic4/Wm4Polynomial1.inl
    WildMagic4/Wm4QuadricSurface.cpp
    WildMagic4/Wm4QuadricSurface.h
    WildMagic4/Wm4Quaternion.cpp
    WildMagic4/Wm4Quaternion.h
    WildMagic4/Wm4Quaternion.inl
    WildMagic4/Wm4Query.h
    WildMagic4/Wm4Query.inl
    WildMagic4/Wm4Query2.h
    WildMagic4/Wm4Query2.inl
    WildMagic4/Wm4Query2Filtered.h
    WildMagic4/Wm4Query2Filtered.inl
    WildMagic4/Wm4Query2Int64.h
    WildMagic4/Wm4Query2Int64.inl
    WildMagic4/Wm4Query2TInteger.h
    WildMagic4/Wm4Query2TInteger.inl
    WildMagic4/Wm4Query2TRational.h
    WildMagic4/Wm4Query2TRational.inl
    WildMagic4/Wm4Query3.h
    WildMagic4/Wm4Query3.inl
    WildMagic4/Wm4Query3Filtered.h
    WildMagic4/Wm4Query3Filtered.inl
    WildMagic4/Wm4Query3Int64.h
    WildMagic4/Wm4Query3Int64.inl
    WildMagic4/Wm4Query3TInteger.h
    WildMagic4/Wm4Query3TInteger.inl
    WildMagic4/Wm4Query3TRational.h
    WildMagic4/Wm4Query3TRational.inl
    WildMagic4/Wm4RVector2.h
    WildMagic4/Wm4RVector2.inl
    WildMagic4/Wm4RVector3.h
    WildMagic4/Wm4RVector3.inl
    WildMagic4/Wm4Segment3.h
    WildMagic4/Wm4Segment3.inl
    WildMagic4/Wm4Sphere3.h
    WildMagic4/Wm4Sphere3.inl
    WildMagic4/Wm4Surface.cpp
    WildMagic4/Wm4Surface.h
    WildMagic4/Wm4System.cpp
    WildMagic4/Wm4System.h
    WildMagic4/Wm4System.inl
    WildMagic4/Wm4THashSet.h
    WildMagic4/Wm4THashSet.inl
    WildMagic4/Wm4THashTable.h
    WildMagic4/Wm4THashTable.inl
    WildMagic4/Wm4TInteger.h
    WildMagic4/Wm4TInteger.inl
    WildMagic4/Wm4TMinHeap.h
    WildMagic4/Wm4TMinHeap.inl
    WildMagic4/Wm4TRVector.h
    WildMagic4/Wm4TRVector.inl
    WildMagic4/Wm4TRational.h
    WildMagic4/Wm4TRational.inl
    WildMagic4/Wm4TSmallUnorderedSet.h
    WildMagic4/Wm4TSmallUnorderedSet.inl
    WildMagic4/Wm4TStringHashTable.h
    WildMagic4/Wm4TStringHashTable.inl
    WildMagic4/Wm4TTuple.h
    WildMagic4/Wm4TTuple.inl
    WildMagic4/Wm4Triangle2.h
    WildMagic4/Wm4Triangle2.inl
    WildMagic4/Wm4Triangle3.h
    WildMagic4/Wm4Triangle3.inl
    WildMagic4/Wm4TriangleKey.h
    WildMagic4/Wm4TriangleKey.inl
    WildMagic4/Wm4TriangulateEC.cpp
    WildMagic4/Wm4TriangulateEC.h
    WildMagic4/Wm4UniqueVerticesTriangles.h
    WildMagic4/Wm4UniqueVerticesTriangles.inl
    WildMagic4/Wm4VEManifoldMesh.cpp
    WildMagic4/Wm4VEManifoldMesh.h
    WildMagic4/Wm4VEManifoldMesh.inl
    WildMagic4/Wm4Vector2.cpp
    WildMagic4/Wm4Vector2.h
    WildMagic4/Wm4Vector2.inl
    WildMagic4/Wm4Vector3.cpp
    WildMagic4/Wm4Vector3.h
    WildMagic4/Wm4Vector3.inl
    WildMagic4/Wm4Vector4.cpp
    WildMagic4/Wm4Vector4.h
    WildMagic4/Wm4Vector4.inl
)
SOURCE_GROUP("WildMagic4" FILES ${WildMagic4_SRCS})

SET(Mesh_SRCS
    ${Mesh_XML_SRCS}
    AppMesh.cpp
    AppMeshPy.cpp
    Exporter.cpp
    Exporter.h
    Importer.cpp
    Importer.h
    Edge.cpp
    Edge.h
    EdgePyImp.cpp
    Facet.cpp
    Facet.h
    FacetPyImp.cpp
    FeatureMeshCurvature.cpp
    FeatureMeshCurvature.h
    FeatureMeshDefects.cpp
    FeatureMeshDefects.h
    FeatureMeshExport.cpp
    FeatureMeshExport.h
    FeatureMeshImport.cpp
    FeatureMeshImport.h
    FeatureMeshSegmentByMesh.cpp
    FeatureMeshSegmentByMesh.h
    FeatureMeshSetOperations.cpp
    FeatureMeshSetOperations.h
    FeatureMeshSolid.cpp
    FeatureMeshSolid.h
    FeatureMeshTransform.cpp
    FeatureMeshTransform.h
    FeatureMeshTransformDemolding.cpp
    FeatureMeshTransformDemolding.h
#   GTSAlgos.cpp
#   GTSAlgos.h
    Mesh.cpp
    Mesh.h
    MeshFeature.cpp
    MeshFeature.h
    MeshFeaturePyImp.cpp
    MeshPointPyImp.cpp
    MeshPoint.h
    MeshProperties.cpp
    MeshProperties.h
    MeshPyImp.cpp
    MeshTexture.cpp
    MeshTexture.h
    PreCompiled.cpp
    PreCompiled.h
    Segment.cpp
    Segment.h
)

# Suppress -Wundefined-var-template
if (MINGW AND CMAKE_COMPILER_IS_CLANGXX)
    unset(_flag_found CACHE)
    check_cxx_compiler_flag("-Wno-undefined-var-template" _flag_found)
    if (_flag_found)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-undefined-var-template")
    endif()
endif()

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${Core_SRCS} ${Mesh_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(Mesh PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

# Suppress some very long Eigen3 warnings of older versions
if (EIGEN3_NO_DEPRECATED_COPY)
    set_source_files_properties(
        Core/Approximation.cpp
        Core/CylinderFit.cpp
        Core/SphereFit.cpp
        Core/KDTree.cpp
        PROPERTIES COMPILE_FLAGS ${EIGEN3_NO_DEPRECATED_COPY})
endif ()

add_library(Mesh SHARED ${Core_SRCS} ${WildMagic4_SRCS} ${Mesh_SRCS})
target_link_libraries(Mesh ${Mesh_LIBS})
set_target_properties(Mesh PROPERTIES CXX_STANDARD_REQUIRED ON)
set_target_properties(Mesh PROPERTIES CXX_STANDARD 17)


SET_BIN_DIR(Mesh Mesh /Mod/Mesh)
SET_PYTHON_PREFIX_SUFFIX(Mesh)

INSTALL(TARGETS Mesh DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Mesh/Gui/CMakeLists.txt ===
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}/Inventor/annex
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

if(MSVC)
    include_directories(
        ${CMAKE_SOURCE_DIR}/src/3rdParty/OpenGL/api
    )
endif(MSVC)

set(MeshGui_LIBS
    ${Boost_LIBRARIES}
    ${OPENGL_glu_LIBRARY}
    Mesh
    FreeCADGui
)

generate_from_xml(ViewProviderMeshPy)

SET(MeshGui_XML_SRCS
    ViewProviderMeshPy.xml
)
SOURCE_GROUP("XML" FILES ${MeshGui_XML_SRCS})

set(Dialogs_UIC_SRCS
    DlgEvaluateMesh.ui
    DlgEvaluateSettings.ui
    DlgRegularSolid.ui
    DlgSettingsMeshView.ui
    DlgSettingsImportExport.ui
    DlgDecimating.ui
    DlgSmoothing.ui
    RemoveComponents.ui
    RemeshGmsh.ui
    Segmentation.ui
    SegmentationBestFit.ui
    Selection.ui
)

SET(Dialogs_SRCS
    ${Dialogs_UIC_HDRS}
    DlgEvaluateMesh.ui
    DlgEvaluateMeshImp.cpp
    DlgEvaluateMeshImp.h
    DlgEvaluateSettings.ui
    DlgEvaluateSettings.cpp
    DlgEvaluateSettings.h
    DlgRegularSolid.ui
    DlgRegularSolidImp.cpp
    DlgRegularSolidImp.h
    DlgSettingsMeshView.ui
    DlgSettingsMeshView.cpp
    DlgSettingsMeshView.h
    DlgSettingsImportExport.ui
    DlgSettingsImportExportImp.cpp
    DlgSettingsImportExportImp.h
    DlgDecimating.ui
    DlgDecimating.cpp
    DlgDecimating.h
    DlgSmoothing.ui
    DlgSmoothing.cpp
    DlgSmoothing.h
    RemoveComponents.ui
    RemoveComponents.cpp
    RemoveComponents.h
    RemeshGmsh.ui
    RemeshGmsh.cpp
    RemeshGmsh.h
    Segmentation.ui
    Segmentation.cpp
    Segmentation.h
    SegmentationBestFit.ui
    SegmentationBestFit.cpp
    SegmentationBestFit.h
    Selection.ui
    Selection.cpp
    Selection.h
)
SOURCE_GROUP("Dialogs" FILES ${Dialogs_SRCS})

SET(Inventor_SRCS
    SoFCIndexedFaceSet.cpp
    SoFCIndexedFaceSet.h
    SoFCMeshObject.cpp
    SoFCMeshObject.h
    SoPolygon.cpp
    SoPolygon.h
)
SOURCE_GROUP("Inventor" FILES ${Inventor_SRCS})

if (BUILD_QT5)
    qt5_wrap_ui(Dialogs_UIC_HDRS ${Dialogs_UIC_SRCS})
    qt5_add_resources(resource_SRCS Resources/Mesh.qrc)
else()
    qt4_wrap_ui(Dialogs_UIC_HDRS ${Dialogs_UIC_SRCS})
    qt4_add_resources(resource_SRCS Resources/Mesh.qrc)
endif()

SET(resource_SRCS
    ${resource_SRCS}
    Resources/Mesh.qrc
)
SOURCE_GROUP("resource" FILES ${resource_SRCS})

SET(ViewProvider_SRCS
    ViewProvider.cpp
    ViewProvider.h
    ViewProviderPython.cpp
    ViewProviderPython.h
    ViewProviderCurvature.cpp
    ViewProviderCurvature.h
    ViewProviderDefects.cpp
    ViewProviderDefects.h
    ViewProviderMeshPyImp.cpp
    ViewProviderMeshFaceSet.cpp
    ViewProviderMeshFaceSet.h
    ViewProviderTransform.cpp
    ViewProviderTransform.h
    ViewProviderTransformDemolding.cpp
    ViewProviderTransformDemolding.h
)
SOURCE_GROUP("ViewProvider" FILES ${ViewProvider_SRCS})

SET(MeshGui_SRCS
    ${MeshGui_XML_SRCS}
    ${Dialogs_SRCS}
    ${Inventor_SRCS}
    ${resource_SRCS}
    ${ViewProvider_SRCS}
    AppMeshGui.cpp
    Command.cpp
    Doxygen.cpp
    PreCompiled.cpp
    PreCompiled.h
    MeshEditor.cpp
    MeshEditor.h
    MeshSelection.cpp
    MeshSelection.h
    PropertyEditorMesh.cpp
    PropertyEditorMesh.h
    Workbench.cpp
    Workbench.h
)

SET(MeshGuiIcon_SVG
    Resources/icons/MeshWorkbench.svg
)

# Suppress this warning for the SbMatrix class
if (EIGEN3_NO_DEPRECATED_COPY)
    set_source_files_properties(
        SoFCIndexedFaceSet.cpp
        ViewProvider.cpp
        PROPERTIES COMPILE_FLAGS ${EIGEN3_NO_DEPRECATED_COPY})
endif ()

add_library(MeshGui SHARED ${MeshGui_SRCS} ${MeshGuiIcon_SVG})
target_link_libraries(MeshGui ${MeshGui_LIBS})


SET_BIN_DIR(MeshGui MeshGui /Mod/Mesh)
SET_PYTHON_PREFIX_SUFFIX(MeshGui)

fc_copy_sources(MeshGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Mesh" ${MeshGuiIcon_SVG})

INSTALL(TARGETS MeshGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${MeshGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Mesh/Resources/icons")

=== src/Mod/Part/App/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DFCAppPart -DHAVE_ACOSH -DHAVE_ASINH -DHAVE_ATANH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)

if(FREETYPE_FOUND)
    add_definitions(-DFCUseFreeType)
endif(FREETYPE_FOUND)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${FREETYPE_INCLUDE_DIRS}
)

link_directories(${OCC_LIBRARY_DIR})

set(Part_LIBS 
    ${OCC_LIBRARIES}
    ${OCC_DEBUG_LIBRARIES}
    FreeCADApp
)

if(FREETYPE_FOUND)
    set(Part_LIBS 
        ${Part_LIBS}
        ${FREETYPE_LIBRARIES}
    )
endif(FREETYPE_FOUND)

generate_from_xml(ArcPy)
generate_from_xml(ArcOfConicPy)
generate_from_xml(ArcOfCirclePy)
generate_from_xml(ArcOfParabolaPy)
generate_from_xml(BodyBasePy)
generate_from_xml(ConicPy)
generate_from_xml(CirclePy)
generate_from_xml(ArcOfEllipsePy)
generate_from_xml(EllipsePy)
generate_from_xml(HyperbolaPy)
generate_from_xml(ArcOfHyperbolaPy)
generate_from_xml(ParabolaPy)
generate_from_xml(OffsetCurvePy)
generate_from_xml(GeometryPy)
generate_from_xml(GeometryExtensionPy)
generate_from_xml(GeometryIntExtensionPy)
generate_from_xml(GeometryStringExtensionPy)
generate_from_xml(GeometryBoolExtensionPy)
generate_from_xml(GeometryDoubleExtensionPy)
generate_from_xml(GeometryCurvePy)
generate_from_xml(BoundedCurvePy)
generate_from_xml(TrimmedCurvePy)
generate_from_xml(GeometrySurfacePy)
generate_from_xml(LinePy)
generate_from_xml(LineSegmentPy)
generate_from_xml(PointPy)
generate_from_xml(BezierCurvePy)
generate_from_xml(BSplineCurvePy)
generate_from_xml(PlanePy)
generate_from_xml(ConePy)
generate_from_xml(CylinderPy)
generate_from_xml(SpherePy)
generate_from_xml(ToroidPy)
generate_from_xml(BezierSurfacePy)
generate_from_xml(BSplineSurfacePy)
generate_from_xml(OffsetSurfacePy)
generate_from_xml(PlateSurfacePy)
generate_from_xml(RectangularTrimmedSurfacePy)
generate_from_xml(SurfaceOfExtrusionPy)
generate_from_xml(SurfaceOfRevolutionPy)
generate_from_xml(PartFeaturePy)
generate_from_xml(AttachExtensionPy)
generate_from_xml(Part2DObjectPy)
generate_from_xml(AttachEnginePy)
generate_from_xml(TopoShapePy)
generate_from_xml(TopoShapeCompoundPy)
generate_from_xml(TopoShapeCompSolidPy)
generate_from_xml(TopoShapeEdgePy)
generate_from_xml(TopoShapeFacePy)
generate_from_xml(TopoShapeShellPy)
generate_from_xml(TopoShapeSolidPy)
generate_from_xml(TopoShapeVertexPy)
generate_from_xml(TopoShapeWirePy)
generate_from_xml(BRepOffsetAPI_MakePipeShellPy)
generate_from_xml(BRepOffsetAPI_MakeFillingPy)
generate_from_xml(PrecisionPy)

# make sure to create the directory at configure time
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/BRepFeat)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ChFi2d)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/Geom2d)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/GeomPlate)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/HLRBRep)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/ShapeUpgrade)

generate_from_xml(BRepFeat/MakePrismPy)

generate_from_xml(ChFi2d/ChFi2d_AnaFilletAlgoPy)
generate_from_xml(ChFi2d/ChFi2d_FilletAlgoPy)
generate_from_xml(ChFi2d/ChFi2d_ChamferAPIPy)
generate_from_xml(ChFi2d/ChFi2d_FilletAPIPy)

generate_from_xml(Geom2d/ArcOfCircle2dPy)
generate_from_xml(Geom2d/ArcOfConic2dPy)
generate_from_xml(Geom2d/ArcOfEllipse2dPy)
generate_from_xml(Geom2d/ArcOfHyperbola2dPy)
generate_from_xml(Geom2d/ArcOfParabola2dPy)
generate_from_xml(Geom2d/BezierCurve2dPy)
generate_from_xml(Geom2d/BSplineCurve2dPy)
generate_from_xml(Geom2d/Circle2dPy)
generate_from_xml(Geom2d/Conic2dPy)
generate_from_xml(Geom2d/Ellipse2dPy)
generate_from_xml(Geom2d/Geometry2dPy)
generate_from_xml(Geom2d/Hyperbola2dPy)
generate_from_xml(Geom2d/Curve2dPy)
generate_from_xml(Geom2d/Line2dSegmentPy)
generate_from_xml(Geom2d/Line2dPy)
generate_from_xml(Geom2d/OffsetCurve2dPy)
generate_from_xml(Geom2d/Parabola2dPy)

generate_from_xml(GeomPlate/BuildPlateSurfacePy)
generate_from_xml(GeomPlate/CurveConstraintPy)
generate_from_xml(GeomPlate/PointConstraintPy)

generate_from_xml(HLRBRep/HLRBRep_AlgoPy)
generate_from_xml(HLRBRep/HLRToShapePy)
generate_from_xml(HLRBRep/HLRBRep_PolyAlgoPy)
generate_from_xml(HLRBRep/PolyHLRToShapePy)

generate_from_xml(ShapeUpgrade/UnifySameDomainPy)

SET(Features_SRCS
    FeaturePartBoolean.cpp
    FeaturePartBoolean.h
    FeaturePartBox.cpp
    FeaturePartBox.h
    FeaturePartCircle.cpp
    FeaturePartCircle.h
    FeaturePartCommon.cpp
    FeaturePartCommon.h
    FeaturePartCurveNet.cpp
    FeaturePartCurveNet.h
    FeaturePartCut.cpp
    FeaturePartCut.h
    FeaturePartFuse.cpp
    FeaturePartFuse.h
    FeaturePartImportBrep.cpp
    FeaturePartImportBrep.h
    FeaturePartImportIges.cpp
    FeaturePartImportIges.h
    FeaturePartImportStep.cpp
    FeaturePartImportStep.h
    FeaturePartPolygon.cpp
    FeaturePartPolygon.h
    FeaturePartSection.cpp
    FeaturePartSection.h
    FeaturePartSpline.cpp
    FeaturePartSpline.h
    FeatureChamfer.cpp
    FeatureChamfer.h
    FeatureCompound.cpp
    FeatureCompound.h
    FeatureExtrusion.cpp
    FeatureExtrusion.h
    FeatureFace.cpp
    FeatureFace.h
    FeatureFillet.cpp
    FeatureFillet.h
    FeatureMirroring.cpp
    FeatureMirroring.h
    FeatureRevolution.cpp
    FeatureRevolution.h
    FeatureOffset.cpp
    FeatureOffset.h
    PartFeatures.cpp
    PartFeatures.h
    PartFeature.cpp
    PartFeature.h
    PartFeatureReference.cpp
    PartFeatureReference.h
    Part2DObject.cpp
    Part2DObject.h
    PrimitiveFeature.cpp
    PrimitiveFeature.h
    FeatureGeometrySet.h
    FeatureGeometrySet.cpp
    CustomFeature.cpp
    CustomFeature.h
    BodyBase.h
    BodyBase.cpp
    DatumFeature.cpp
    DatumFeature.h
    AttachExtension.h
    AttachExtension.cpp
    PrismExtension.cpp
    PrismExtension.h
)
SOURCE_GROUP("Features" FILES ${Features_SRCS})

SET(Properties_SRCS
    PropertyTopoShape.cpp
    PropertyTopoShape.h
    PropertyGeometryList.cpp
    PropertyGeometryList.h
)
SOURCE_GROUP("Properties" FILES ${Properties_SRCS})

SET(Python_SRCS
    ArcPy.xml
    ArcPyImp.cpp
    ArcOfConicPy.xml
    ArcOfConicPyImp.cpp
    ArcOfCirclePy.xml
    ArcOfCirclePyImp.cpp
    ArcOfParabolaPy.xml
    ArcOfParabolaPyImp.cpp
    BodyBasePy.xml
    BodyBasePyImp.cpp
    ConicPy.xml
    ConicPyImp.cpp
    CirclePy.xml
    CirclePyImp.cpp
    ArcOfEllipsePy.xml
    ArcOfEllipsePyImp.cpp
    EllipsePy.xml
    EllipsePyImp.cpp
    HyperbolaPy.xml
    HyperbolaPyImp.cpp
    ArcOfHyperbolaPy.xml
    ArcOfHyperbolaPyImp.cpp
    ParabolaPy.xml
    ParabolaPyImp.cpp
    OffsetCurvePy.xml
    OffsetCurvePyImp.cpp
    GeometryPy.xml
    GeometryPyImp.cpp
    GeometryExtensionPy.xml
    GeometryExtensionPyImp.cpp
    GeometryIntExtensionPy.xml
    GeometryIntExtensionPyImp.cpp
    GeometryStringExtensionPy.xml
    GeometryStringExtensionPyImp.cpp
    GeometryBoolExtensionPy.xml
    GeometryBoolExtensionPyImp.cpp
    GeometryDoubleExtensionPy.xml
    GeometryDoubleExtensionPyImp.cpp
    GeometryCurvePy.xml
    GeometryCurvePyImp.cpp
    BoundedCurvePy.xml
    BoundedCurvePyImp.cpp
    TrimmedCurvePy.xml
    TrimmedCurvePyImp.cpp
    GeometrySurfacePy.xml
    GeometrySurfacePyImp.cpp
    LinePy.xml
    LinePyImp.cpp
    LineSegmentPy.xml
    LineSegmentPyImp.cpp
    PointPy.xml
    PointPyImp.cpp
    BezierCurvePy.xml
    BezierCurvePyImp.cpp
    BSplineCurvePy.xml
    BSplineCurvePyImp.cpp
    PlanePy.xml
    PlanePyImp.cpp
    ConePy.xml
    ConePyImp.cpp
    CylinderPy.xml
    CylinderPyImp.cpp
    SpherePy.xml
    SpherePyImp.cpp
    ToroidPy.xml
    ToroidPyImp.cpp
    BezierSurfacePy.xml
    BezierSurfacePyImp.cpp
    BSplineSurfacePy.xml
    BSplineSurfacePyImp.cpp
    OffsetSurfacePy.xml
    OffsetSurfacePyImp.cpp
    PlateSurfacePy.xml
    PlateSurfacePyImp.cpp
    RectangularTrimmedSurfacePy.xml
    RectangularTrimmedSurfacePyImp.cpp
    SurfaceOfExtrusionPy.xml
    SurfaceOfExtrusionPyImp.cpp
    SurfaceOfRevolutionPy.xml
    SurfaceOfRevolutionPyImp.cpp
    PartFeaturePy.xml
    PartFeaturePyImp.cpp
    AttachExtensionPy.xml
    AttachExtensionPyImp.cpp
    Part2DObjectPy.xml
    Part2DObjectPyImp.cpp
    AttachEnginePy.xml
    AttachEnginePyImp.cpp
    TopoShapePy.xml
    TopoShapePyImp.cpp
    TopoShapeCompSolidPy.xml
    TopoShapeCompSolidPyImp.cpp
    TopoShapeCompoundPy.xml
    TopoShapeCompoundPyImp.cpp
    TopoShapeEdgePy.xml
    TopoShapeEdgePyImp.cpp
    TopoShapeFacePy.xml
    TopoShapeFacePyImp.cpp
    TopoShapeShellPy.xml
    TopoShapeShellPyImp.cpp
    TopoShapeSolidPy.xml
    TopoShapeSolidPyImp.cpp
    TopoShapeVertexPy.xml
    TopoShapeVertexPyImp.cpp
    TopoShapeWirePy.xml
    TopoShapeWirePyImp.cpp
    BRepOffsetAPI_MakePipeShellPy.xml
    BRepOffsetAPI_MakePipeShellPyImp.cpp
    BRepOffsetAPI_MakeFillingPy.xml
    BRepOffsetAPI_MakeFillingPyImp.cpp
    PrecisionPy.xml
    PrecisionPyImp.cpp
    PartPyCXX.cpp
    PartPyCXX.h
)
SOURCE_GROUP("Python" FILES ${Python_SRCS})

# BRepFeat wrappers
SET(BRepFeatPy_SRCS
    BRepFeat/MakePrismPy.xml
    BRepFeat/MakePrismPyImp.cpp
)
SOURCE_GROUP("BRepFeat" FILES ${BRepFeatPy_SRCS})

# ChFi2d wrappers
SET(ChFi2dPy_SRCS
    ChFi2d/ChFi2d_AnaFilletAlgoPy.xml
    ChFi2d/ChFi2d_AnaFilletAlgoPyImp.cpp
    ChFi2d/ChFi2d_FilletAlgoPy.xml
    ChFi2d/ChFi2d_FilletAlgoPyImp.cpp
    ChFi2d/ChFi2d_ChamferAPIPy.xml
    ChFi2d/ChFi2d_ChamferAPIPyImp.cpp
    ChFi2d/ChFi2d_FilletAPIPy.xml
    ChFi2d/ChFi2d_FilletAPIPyImp.cpp
)
SOURCE_GROUP("ChFi2d" FILES ${ChFi2dPy_SRCS})

# Geom2d wrappers
SET(Geom2dPy_SRCS
    Geom2d/ArcOfCircle2dPy.xml
    Geom2d/ArcOfCircle2dPyImp.cpp
    Geom2d/ArcOfConic2dPy.xml
    Geom2d/ArcOfConic2dPyImp.cpp
    Geom2d/ArcOfEllipse2dPy.xml
    Geom2d/ArcOfEllipse2dPyImp.cpp
    Geom2d/ArcOfHyperbola2dPy.xml
    Geom2d/ArcOfHyperbola2dPyImp.cpp
    Geom2d/ArcOfParabola2dPy.xml
    Geom2d/ArcOfParabola2dPyImp.cpp
    Geom2d/BezierCurve2dPy.xml
    Geom2d/BezierCurve2dPyImp.cpp
    Geom2d/BSplineCurve2dPy.xml
    Geom2d/BSplineCurve2dPyImp.cpp
    Geom2d/Circle2dPy.xml
    Geom2d/Circle2dPyImp.cpp
    Geom2d/Conic2dPy.xml
    Geom2d/Conic2dPyImp.cpp
    Geom2d/Ellipse2dPy.xml
    Geom2d/Ellipse2dPyImp.cpp
    Geom2d/Geometry2dPy.xml
    Geom2d/Geometry2dPyImp.cpp
    Geom2d/Curve2dPy.xml
    Geom2d/Curve2dPyImp.cpp
    Geom2d/Hyperbola2dPy.xml
    Geom2d/Hyperbola2dPyImp.cpp
    Geom2d/Line2dPy.xml
    Geom2d/Line2dPyImp.cpp
    Geom2d/Line2dSegmentPy.xml
    Geom2d/Line2dSegmentPyImp.cpp
    Geom2d/OffsetCurve2dPy.xml
    Geom2d/OffsetCurve2dPyImp.cpp
    Geom2d/Parabola2dPy.xml
    Geom2d/Parabola2dPyImp.cpp
)

SOURCE_GROUP("Geom2d" FILES ${Geom2dPy_SRCS})

# GeomPlate wrappers
SET(GeomPlatePy_SRCS
    GeomPlate/BuildPlateSurfacePy.xml
    GeomPlate/BuildPlateSurfacePyImp.cpp
    GeomPlate/CurveConstraintPy.xml
    GeomPlate/CurveConstraintPyImp.cpp
    GeomPlate/PointConstraintPy.xml
    GeomPlate/PointConstraintPyImp.cpp
)

SOURCE_GROUP("GeomPlate" FILES ${GeomPlatePy_SRCS})

# HLRBRep wrappers
SET(HLRBRepPy_SRCS
    HLRBRep/HLRBRep_AlgoPy.xml
    HLRBRep/HLRBRep_AlgoPyImp.cpp
    HLRBRep/HLRToShapePy.xml
    HLRBRep/HLRToShapePyImp.cpp

    HLRBRep/HLRBRep_PolyAlgoPy.xml
    HLRBRep/HLRBRep_PolyAlgoPyImp.cpp
    HLRBRep/PolyHLRToShapePy.xml
    HLRBRep/PolyHLRToShapePyImp.cpp
)
SOURCE_GROUP("HLRBRep" FILES ${HLRBRepPy_SRCS})

# ShapeUpgrade wrappers
SET(ShapeUpgradePy_SRCS
    ShapeUpgrade/UnifySameDomainPy.xml
    ShapeUpgrade/UnifySameDomainPyImp.cpp
)

SOURCE_GROUP("ShapeUpgrade" FILES ${ShapeUpgradePy_SRCS})

SET(Part_SRCS
    ${Features_SRCS}
    ${Properties_SRCS}
    ${Python_SRCS}
    ${BRepFeatPy_SRCS}
    ${ChFi2dPy_SRCS}
    ${Geom2dPy_SRCS}
    ${GeomPlatePy_SRCS}
    ${HLRBRepPy_SRCS}
    ${ShapeUpgradePy_SRCS}
    Attacher.cpp
    Attacher.h
    AppPart.cpp
    AppPartPy.cpp
    BRepOffsetAPI_MakeOffsetFix.cpp
    BRepOffsetAPI_MakeOffsetFix.h
    BSplineCurveBiArcs.cpp
    CrossSection.cpp

=== src/Mod/Part/Gui/CMakeLists.txt ===
if(MSVC)
    add_definitions(-DHAVE_ACOSH -DHAVE_ATANH -DHAVE_ASINH)
else(MSVC)
    add_definitions(-DHAVE_LIMITS_H -DHAVE_CONFIG_H)
endif(MSVC)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${COIN3D_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)
link_directories(${OCC_LIBRARY_DIR})

set(PartGui_LIBS
    Part
    FreeCADGui
)

if(MSVC)
    include_directories(
        ${CMAKE_SOURCE_DIR}/src/3rdParty/OpenGL/api
    )
endif(MSVC)

if (BUILD_QT5)
    include_directories(
        ${Qt5Concurrent_INCLUDE_DIRS}
    )
    list(APPEND PartGui_LIBS
        ${Qt5Concurrent_LIBRARIES}
    )
endif()

if (BUILD_QT5)
    qt5_add_resources(PartGui_QRC_SRCS Resources/Part.qrc)
else()
    qt4_add_resources(PartGui_QRC_SRCS Resources/Part.qrc)
endif()

set(PartGui_UIC_SRCS
    CrossSections.ui
    Mirroring.ui
    DlgBooleanOperation.ui
    DlgExtrusion.ui
    DlgFilletEdges.ui
    DlgImportExportIges.ui
    DlgImportExportStep.ui
    DlgPartBox.ui
    DlgPartCylinder.ui
    DlgPartImportIges.ui
    DlgPartImportStep.ui
    DlgPrimitives.ui
    Location.ui
    DlgRevolution.ui
    DlgSettings3DViewPart.ui
    DlgSettingsGeneral.ui
    DlgSettingsObjectColor.ui
    DlgProjectionOnSurface.ui
    SectionCutting.ui
    ShapeFromMesh.ui
    TaskFaceColors.ui
    TaskShapeBuilder.ui
    TaskLoft.ui
    TaskOffset.ui
    TaskSweep.ui
    TaskAttacher.ui
)

if (BUILD_QT5)
    qt5_wrap_ui(PartGui_UIC_HDRS ${PartGui_UIC_SRCS})
else()
    qt4_wrap_ui(PartGui_UIC_HDRS ${PartGui_UIC_SRCS})
endif()

SET(PartGui_SRCS
    ${PartGui_QRC_SRCS}
    ${PartGui_UIC_HDRS}
    AppPartGui.cpp
    AttacherTexts.h
    AttacherTexts.cpp
    BoxSelection.cpp
    BoxSelection.h
    Command.cpp
    CommandSimple.cpp
    CommandParametric.cpp
    CrossSections.cpp
    CrossSections.h
    CrossSections.ui
    Mirroring.cpp
    Mirroring.h
    Mirroring.ui
    DlgBooleanOperation.cpp
    DlgBooleanOperation.h
    DlgBooleanOperation.ui
    DlgExtrusion.cpp
    DlgExtrusion.h
    DlgExtrusion.ui
    DlgFilletEdges.cpp
    DlgFilletEdges.h
    DlgFilletEdges.ui
    DlgImportExportIges.ui
    DlgImportExportStep.ui
    DlgPartBox.ui
    DlgPartBoxImp.cpp
    DlgPartBoxImp.h
    DlgPartCylinderImp.cpp
    DlgPartCylinderImp.h
    DlgPartCylinder.ui
    DlgPartImportIges.ui
    DlgPartImportIgesImp.cpp
    DlgPartImportIgesImp.h
    DlgPartImportStep.ui
    DlgPartImportStepImp.cpp
    DlgPartImportStepImp.h
    DlgPrimitives.cpp
    DlgPrimitives.h
    DlgPrimitives.ui
    Location.ui
    DlgRevolution.cpp
    DlgRevolution.h
    DlgRevolution.ui
    DlgSettings3DViewPart.ui
    DlgSettings3DViewPartImp.cpp
    DlgSettings3DViewPartImp.h
    DlgSettingsGeneral.cpp
    DlgSettingsGeneral.h
    DlgSettingsGeneral.ui
    DlgSettingsObjectColor.cpp
    DlgSettingsObjectColor.h
    DlgSettingsObjectColor.ui
    DlgProjectionOnSurface.cpp
    DlgProjectionOnSurface.h
    DlgProjectionOnSurface.ui
    Resources/Part.qrc
    PreCompiled.cpp
    PreCompiled.h
    PropertyEnumAttacherItem.cpp
    PropertyEnumAttacherItem.h
    SoFCShapeObject.cpp
    SoFCShapeObject.h
    SoBrepEdgeSet.cpp
    SoBrepEdgeSet.h
    SoBrepFaceSet.cpp
    SoBrepFaceSet.h
    SoBrepPointSet.cpp
    SoBrepPointSet.h
    ViewProvider.cpp
    ViewProvider.h
    ViewProviderAttachExtension.h
    ViewProviderAttachExtension.cpp
    ViewProviderExt.cpp
    ViewProviderExt.h
    ViewProviderReference.cpp
    ViewProviderReference.h
    ViewProviderBox.cpp
    ViewProviderBox.h
    ViewProviderCompound.cpp
    ViewProviderCompound.h
    ViewProviderCircleParametric.cpp
    ViewProviderCircleParametric.h
    ViewProviderLineParametric.cpp
    ViewProviderLineParametric.h
    ViewProviderPointParametric.cpp
    ViewProviderPointParametric.h
    ViewProviderEllipseParametric.cpp
    ViewProviderEllipseParametric.h
    ViewProviderHelixParametric.cpp
    ViewProviderHelixParametric.h
    ViewProviderPlaneParametric.cpp
    ViewProviderPlaneParametric.h
    ViewProviderSphereParametric.cpp
    ViewProviderSphereParametric.h
    ViewProviderCylinderParametric.cpp
    ViewProviderCylinderParametric.h
    ViewProviderConeParametric.cpp
    ViewProviderConeParametric.h
    ViewProviderPrism.cpp
    ViewProviderPrism.h
    ViewProviderRegularPolygon.cpp
    ViewProviderRegularPolygon.h
    ViewProviderTorusParametric.cpp
    ViewProviderTorusParametric.h
    ViewProviderCurveNet.cpp
    ViewProviderCurveNet.h
    ViewProviderSpline.cpp
    ViewProviderSpline.h
    ViewProviderImport.cpp
    ViewProviderImport.h
    ViewProviderExtrusion.cpp
    ViewProviderExtrusion.h
    ViewProvider2DObject.cpp
    ViewProvider2DObject.h
    ViewProviderMirror.cpp
    ViewProviderMirror.h
    ViewProviderPython.cpp
    ViewProviderPython.h
    ViewProviderBoolean.cpp
    ViewProviderBoolean.h
    ViewProviderRuledSurface.cpp
    ViewProviderRuledSurface.h
    ViewProviderPrimitive.cpp
    ViewProviderPrimitive.h
    Workbench.cpp
    Workbench.h
    ReferenceHighlighter.cpp
    ReferenceHighlighter.h
    SectionCutting.cpp
    SectionCutting.h
    SectionCutting.ui
    ShapeFromMesh.cpp
    ShapeFromMesh.h
    TaskFaceColors.cpp
    TaskFaceColors.h
    TaskFaceColors.ui
    TaskShapeBuilder.cpp
    TaskShapeBuilder.h
    TaskShapeBuilder.ui
    TaskLoft.cpp
    TaskLoft.h
    TaskLoft.ui
    TaskOffset.cpp
    TaskOffset.h
    TaskOffset.ui
    TaskSweep.cpp
    TaskSweep.h
    TaskSweep.ui
    TaskThickness.cpp
    TaskThickness.h
    TaskDimension.cpp
    TaskDimension.h
    TaskCheckGeometry.cpp
    TaskCheckGeometry.h
    TaskAttacher.h
    TaskAttacher.cpp
)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${PartGui_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(PartGui PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

SET(PartGuiIcon_SVG
    Resources/icons/PartWorkbench.svg
)

add_library(PartGui SHARED ${PartGui_SRCS} ${PartGuiIcon_SVG})
target_link_libraries(PartGui ${PartGui_LIBS})


SET_BIN_DIR(PartGui PartGui /Mod/Part)
SET_PYTHON_PREFIX_SUFFIX(PartGui)

fc_copy_sources(PartGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Part" ${PartGuiIcon_SVG})

INSTALL(TARGETS PartGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${PartGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Part/Resources/icons")

=== debian/changelog ===
freecad (0.20.1+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * autopkgtest: Disable test TestPathApp on s390x.

 -- Tobias Frost <tobi@debian.org>  Fri, 09 Sep 2022 17:01:54 +0200

freecad (0.20.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.

 -- Tobias Frost <tobi@debian.org>  Fri, 26 Aug 2022 23:58:01 +0200

freecad (0.20+dfsg1-6) unstable; urgency=medium

  * Revert running freecad in the autopkgtest, this needs more work.

 -- Tobias Frost <tobi@debian.org>  Thu, 18 Aug 2022 21:30:34 +0200

freecad (0.20+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * Disable test femtest.app.test_solver_calculix.TestSolverCalculix, as
    this test is currently broken on some archs. Closes: #1017598.
  * Run freecad (gui executeable) test suite also in the autopkgtest,
    in the hope that missing libraries will be caught too (see #1013881).

 -- Tobias Frost <tobi@debian.org>  Thu, 18 Aug 2022 12:38:22 +0200

freecad (0.20+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on armel and armhf, GL_PROJECTION not declared in this scope
    with patch fix-1014875-arm-FTBFS.patch (Closes: #1014875)

 -- Tobias Frost <tobi@debian.org>  Tue, 09 Aug 2022 18:37:51 +0200

freecad (0.20+dfsg1-3) UNRELEASED; urgency=medium

  * d/u/metadata: Added SciCrunch RRID:SCR_022535

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Jul 2022 21:17:32 +0200

freecad (0.20+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * More verbose description.

 -- Steffen Moeller <moeller@debian.org>  Tue, 05 Jul 2022 02:16:00 +0200

freecad (0.20+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version. (Closes: #1007013)
  * Removed surface_extended_patch.patch - already found upstream
  * Removed remove_doc-files.patch - no longer applicable/needed
  * Removed fix_vtk9.patch - addressed upstream
  * Standards-Version: 4.6.1 (routine-update)
  * Extended runtime dependencies on python Qt modules as instructed
    upon execution of freecad.

 -- Steffen Moeller <moeller@debian.org>  Mon, 04 Jul 2022 15:29:38 +0200

freecad (0.19.4+dfsg1-1) unstable; urgency=medium

  * Team upload.

  * New upstream version - a bug-fix release
    Release notes: https://github.com/FreeCAD/FreeCAD/releases/tag/0.19.4
    - Fixes CVE-2021-45844 (Closes: #1005747)
    - Fixes CVE-2021-45845
  * Added link-time optimization

 -- Steffen Moeller <moeller@debian.org>  Fri, 04 Mar 2022 16:01:45 +0100

freecad (0.19.3+dfsg1-2) unstable; urgency=medium

  * Team upload.

  [ Håvard Flaget Aasen ]
  * Move files from /usr/share/freecad/share/* to /usr/share/*
  * Move appstream files from freecad-common to freecad, specifically
    /usr/share/applications/*, /usr/share/metainfo/* and /usr/share/mime/*.
    This will make sofware relying on appstream to install correct package.
    (Closes: #981175)
  * Don't install .xpm icon.
  * Prefer upstream version of desktop and sharedmimeinfo files.
  * Explicitly list folders to install in freecad-common.
  * Add patch to include previous set option in desktop file.
    Making freecad only run as single instance.

  [ Tobias Frost ]
  * Fix filename of SurfaceExtend icon (Closes: #992715)

 -- Steffen Moeller <moeller@debian.org>  Fri, 25 Feb 2022 14:04:59 +0100

freecad (0.19.3+dfsg1-1) unstable; urgency=medium

  * Team upload.

  [ Tobias Frost ]
  * Tighten dependencies on metapackage, so that the right version
    of all packages will be pulled on update. (Closes: #980474)

  [ Steffen Moeller ]
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * watch file standard 4 (routine-update)
  * patch/python3.8 adopted upstream
  * improved d/rules clean target for repeated builds

 -- Tobias Frost <tobi@debian.org>  Fri, 22 Oct 2021 12:45:02 +0200

=== debian/control ===
Source: freecad
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Kuzminsky <seb@highlab.com>,
           Kurt Kremitzki <kkremitzki@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-exec,
               dh-python,
               libboost-date-time-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-serialization-dev,
               libboost-thread-dev,
               libcoin-dev,
               libdouble-conversion-dev,
               libglew-dev,
               liblz4-dev,
               libopencv-dev,
               libeigen3-dev,
               libgts-bin,
               libgts-dev,
               libkdtree++-dev,
               libmedc-dev,
               libmetis-dev,
               libocct-data-exchange-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libproj-dev,
               libpyside2-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libqt5xmlpatterns5-dev,
               libqt5x11extras5-dev,
               libshiboken2-dev,
               libspnav-dev,
               libvtk9-dev,
               libx11-dev,
               libxerces-c-dev,
               libzipios++-dev,
               lsb-release,
               occt-draw,
               pybind11-dev,
               pyqt5-dev-tools,
               pyside2-tools,
               python3-dev,
               python3-matplotlib,
               python3-ply,
               python3-pyside2.qtcore,
               python3-pyside2.qtgui,
               python3-pyside2.qtsvg,
               python3-pyside2.qtuitools,
               python3-pyside2.qtwidgets,
               python3-pyside2.qtxml,
               python3-requests,
               qtbase5-dev,
               qttools5-dev,
               swig
Build-Depends-Indep: doxygen
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/freecad
Vcs-Git: https://salsa.debian.org/science-team/freecad.git
Homepage: https://freecadweb.org/
Rules-Requires-Root: no

Package: freecad
Architecture: all
Depends: freecad-python3 (>= ${source:Version}),
         freecad-python3 (<< ${source:Version}.1~),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: calculix-ccx,
            graphviz
Suggests: povray
Breaks: freecad (<< 0.18)
Replaces: freecad (<< 0.18)
Description: Extensible Open Source CAx program
 For 3D printing, CNC milling or for the manual assembly of complicated
 constructs one needs a formal specification of the workpiece, i.e.,
 its parts and how these come together. The process to get there is
 called Computer-Aided Design (CAD). The process to transform a CAD
 model into a series of instructions that can be performed on a machine
 is called Computer-Aided Manufacturing (CAM). FreeCAD can do both, the
 prior yet a bit better than the latter.
 .
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This is a metapackage of FreeCAD component packages.

Package: freecad-python3
Architecture: any
Depends: freecad-common (= ${source:Version}),
         python3-matplotlib,
         python3-pivy,
         python3-ply,
         python3-pyside2.qtcore,
         python3-pyside2.qtgui,
         python3-pyside2.qtnetwork,
         python3-pyside2.qtsvg,
         python3-pyside2.qtuitools,
         python3-pyside2.qtwidgets,
         python3-pyside2.qtxml,
         python3-yaml,
         libfreecad-python3-0.20 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: python3-pyside2.qtwebchannel,
            python3-pyside2.qtwebengine,
            python3-pyside2.qtwebenginecore,
            python3-pyside2.qtwebenginewidgets
Breaks: libfreecad-python2-0.17
Replaces: libfreecad-python2-0.17
Description: Extensible Open Source CAx program - Python 3 binaries
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains the FreeCAD binaries built against Python 3.

Package: freecad-common
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: freecad (<< 0.18),
        freecad-python2 (<< 0.18),
        freecad-runtime (<< 0.20)
Replaces: freecad (<< 0.18),
          freecad-python2 (<< 0.18),
          freecad-runtime (<< 0.20)
Multi-Arch: foreign
Description: Extensible Open Source CAx program - common files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains FreeCAD common files and resources.

Package: libfreecad-python3-0.20
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libfreecad-python3-0.18,libfreecad-python3-0.19
Replaces: libfreecad-python3-0.18,libfreecad-python3-0.19
Description: Extensible Open Source CAx program - Python 3 library files
 FreeCAD is an Open Source CAx RAD based on OpenCasCade, Qt and Python.
 It features some key concepts like macro recording, workbenches, ability
 to run as a server and dynamically loadable application extensions and
 it is designed to be platform independent.
 .
 Currently, FreeCAD can import and display CAD models in IGES, STEP, and
 BRep formats and meshes in STL, BMS, AST and Wavefront OBJ formats.
 Editing and modeling features are currently somewhat limited.
 .
 This package contains shared library files for FreeCAD built against Python 3.
